SystemOrganization addCategory: #'Phexample-Core'!
SystemOrganization addCategory: #'Phexample-Test'!

!Object methodsFor: '*phexample-core' stamp: 'JoeExample 11/8/2009 22:34'!
should
	^PhexMatcher with: self! !

Object subclass: #PhexMatcher
	instanceVariableNames: 'value state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phexample-Core'!

!PhexMatcher class methodsFor: 'documentation' stamp: 'AdrianKuhn 11/9/2009 10:24'!
rewriteRules
	^RBParseTreeRewriter new
		replace: 'self assert: [ `@expression ]' with: 'self assert: `@expression';
		replace: 'self deny: `@expression' with: 'self assert: `@expression not';
		replace: 'self assert: `@value = `@expected' with: '`@value should = `@expected';
		replace: 'self assert: `@value ~= `@expected' with: '`@value should not = `@expected';
		replace: 'self assert: `@value > `@expected' with: '`@value should > `@expected';
		replace: 'self assert: `@value < `@expected' with: '`@value should < `@expected';
		replace: 'self assert: `@value >= `@expected' with: '`@value should >= `@expected';
		replace: 'self assert: `@value <= `@expected' with: '`@value should <= `@expected';
		replace: 'self assert: (`@value isKindOf: `@type)' with: '`@value should beKindOf: `@type';
		replace: 'self assert: `@expression isNil' with: '`@expression should be isNil';
		replace: 'self assert: `@expression notNil' with: '`@expression should be notNil';
		replace: 'self assert: `@expression `test not' with: '`@expression should not be `test'
			when: [:node | node arguments first receiver selector matchesRegex: '(is|has|not).+|atEnd' ];
		replace: 'self assert: `@expression `test' with: '`@expression should be `test'
			when: [:node | node arguments first selector matchesRegex: '(is|has|not).+|atEnd' ];
		replace: 'self assert: (`@collection includes: `@element) not' with: '`@collection should not be includes: `@element';
		replace: 'self assert: (`@collection includes: `@element)' with: '`@collection should be includes: `@element';
		yourself.
	
! !

!PhexMatcher class methodsFor: 'creation' stamp: 'AdrianNiko 10/14/2009 09:24'!
with: anObject 
	^ self new setValue: anObject! !

!PhexMatcher methodsFor: 'expecting' stamp: 'JoeExample 10/27/2009 18:35'!
< expected
	^self expect: expected using: #<! !

!PhexMatcher methodsFor: 'expecting' stamp: 'JoeExample 10/27/2009 18:35'!
<= expected
	^self expect: expected using: #<=! !

!PhexMatcher methodsFor: 'expecting' stamp: 'AdrianKuhn 11/20/2009 18:46'!
= expected
	self expect: expected using: #=.
	self isShould ifTrue: [ self expectSameHash: expected ].
	^nil
	! !

!PhexMatcher methodsFor: 'expecting' stamp: 'JoeExample 10/27/2009 18:35'!
> expected
	^self expect: expected using: #>! !

!PhexMatcher methodsFor: 'expecting' stamp: 'JoeExample 10/27/2009 18:35'!
>= expected
	^self expect: expected using: #>=! !

!PhexMatcher methodsFor: 'expecting-boolean' stamp: 'AdrianNiko 10/14/2009 17:36'!
be
	state := state copyWith: #be! !

!PhexMatcher methodsFor: 'expecting-reflection' stamp: 'AdrianKuhn 11/9/2009 05:39'!
beKindOf: expectedClass 
	^self 
		expect: [ value isKindOf: expectedClass ]
		describeShould: 
			[ 'expected kind of <1p> but got instance of <2p> (using isKindOf)' 
				expandMacrosWith: expectedClass
				with: value class ]
		describeShouldNot: 
			[ 'expected not to get kind of <1p> but got instance of <2p> (using isKindOf)' 
				expandMacrosWith: expectedClass
				with: value class ]! !

!PhexMatcher methodsFor: 'expecting-string' stamp: 'AdrianKuhn 11/9/2009 08:56'!
beginWith: aPrefix
	^self expect: aPrefix using: #beginsWith: 
	! !

!PhexMatcher methodsFor: 'expecting-change' stamp: 'TestRunner 11/9/2009 04:55'!
change: aBlock 
	| before after |
	before := aBlock value.
	value value.
	after := aBlock value.
	before should not = after.	! !

!PhexMatcher methodsFor: 'expecting-change' stamp: 'TestRunner 11/9/2009 05:00'!
change: aBlock from: before to: after
	aBlock value should = before.
	value value.
	aBlock value should = after.! !

!PhexMatcher methodsFor: 'private' stamp: 'AdrianKuhn 11/9/2009 08:37'!
doesNotUnderstand: aMessage
	state = #(be) ifTrue: [
		TestCase new assert: (aMessage sendTo: value) equals: true.
		^self ].
	state = #(not be) ifTrue: [
		TestCase new assert: (aMessage sendTo: value) equals: false.
		^self ].
	super doesNotUnderstand: aMessage
	! !

!PhexMatcher methodsFor: 'expecting-string' stamp: 'AdrianKuhn 11/9/2009 08:57'!
endWith: aSuffix
	^self expect: aSuffix using: #endsWith: 
	! !

!PhexMatcher methodsFor: 'private' stamp: 'AdrianKuhn 11/20/2009 18:26'!
expect: aBlock describeShould: shouldBlock describeShouldNot: shouldNotBlock
	self isShould ifTrue: [
		aBlock value ifFalse: [TestFailure signal: shouldBlock value].
		^nil ].
	self isShouldNot ifTrue: [
		aBlock value ifTrue: [TestFailure signal: shouldNotBlock value].
		^nil ].
	self error: 'illegal state ', state asString! !

!PhexMatcher methodsFor: 'private' stamp: 'AdrianKuhn 11/9/2009 08:55'!
expect: expected using: aSymbol
	^self expect: [ value perform: aSymbol with: expected ]
  		describeShould: [ ('expected <1p> but got <2p> (using <3s>)'
								expandMacrosWith: expected
								with: value
								with: aSymbol) ]
  		describeShouldNot: [ ('expected not to get <1p> but got <2p> (using <3s>)'
								expandMacrosWith: expected
								with: value
								with: aSymbol) ]
! !

!PhexMatcher methodsFor: 'private' stamp: 'AdrianKuhn 11/20/2009 18:51'!
expectSameHash: expected
	value hash = expected hash ifFalse: [
		TestFailure signal: ('Expected same hash value for <1p> and <2p> (using hash implied by =)'
			expandMacrosWith: value
			with: expected) ].
	^nil! !

!PhexMatcher methodsFor: 'expecting-boolean' stamp: 'TestRunner 10/27/2009 17:06'!
false
	state = #(be) ifTrue: [ state := #(). ^self = false ].
	state = #(not be) ifTrue: [ state := #(). ^self ~= false ].
	Error signal: 'Illegal state ', state asString! !

!PhexMatcher methodsFor: 'private' stamp: 'AdrianNiko 10/14/2009 17:35'!
initialize 
 state := #()! !

!PhexMatcher methodsFor: 'private' stamp: 'AdrianKuhn 11/20/2009 18:25'!
isShould
	^state = #()! !

!PhexMatcher methodsFor: 'private' stamp: 'AdrianKuhn 11/20/2009 18:25'!
isShouldNot
	^state = #(not)! !

!PhexMatcher methodsFor: 'expecting-string' stamp: 'AdrianKuhn 11/9/2009 05:37'!
matchRegex: regexString
	
	^self expect: regexString using: #matchesRegex:! !

!PhexMatcher methodsFor: 'expecting' stamp: 'AdrianNiko 10/14/2009 17:36'!
not
	state := state copyWith: #not! !

!PhexMatcher methodsFor: 'expecting-reflection' stamp: 'AdrianKuhn 11/12/2009 00:37'!
respondTo: aSelector
	^self 
		expect: [ value respondsTo: aSelector ]
		describeShould: 
			[ 'expected <1p> to respond to <2p> (using respondsTo:)' 
				expandMacrosWith: value 
			   with: aSelector ]
		describeShouldNot: 
			[ 'expected <1p> not to respond to <2p> (using respondsTo:)' 
				expandMacrosWith: value 
			   with: aSelector ]! !

!PhexMatcher methodsFor: 'expecting-performance' stamp: 'AdrianKuhn 11/9/2009 06:27'!
runWithin: aDuration 
	^ self
		expect: [[value value.
			true]
				valueWithin: aDuration
				onTimeout: [false]]
		describeShould: ['expected to run within <1p> but took longer' expandMacrosWith: aDuration]
		describeShouldNot: ['expected to take longer then <1p> but was faster' expandMacrosWith: aDuration]! !

!PhexMatcher methodsFor: 'private' stamp: 'AdrianNiko 10/14/2009 09:25'!
setValue: anObject
	value := anObject ! !

!PhexMatcher methodsFor: 'expecting-error' stamp: 'JoeExample 10/27/2009 10:40'!
signal: errorClass 
	
	value on: Exception do: [ :ex |
		^ex should beKindOf: errorClass ].
	TestFailure signal: ('Should raise <1p> but was none' expandMacrosWith: errorClass).! !

!PhexMatcher methodsFor: 'expecting-error' stamp: 'JoeExample 10/27/2009 18:08'!
signal: errorClass withMessageText: message

	value on: Exception do: [ :ex | 
		ex should beKindOf: errorClass.
		^message isBlock 
			ifTrue: [ message value: ex messageText ]
			ifFalse: [ ^ex messageText should = message ]].
	TestFailure signal: ('Should raise <1p> but was none' expandMacrosWith: errorClass).! !

!PhexMatcher methodsFor: 'expecting-boolean' stamp: 'TestRunner 10/27/2009 17:06'!
true
	state = #(be) ifTrue: [ state := #(). ^self = true ].
	state = #(not be) ifTrue: [ state := #(). ^self ~= true ].
	Error signal: 'Illegal state ', state asString! !

!PhexMatcher methodsFor: 'expecting' stamp: 'AdrianKuhn 11/20/2009 18:26'!
~= expected
	self expect: expected using: #~=.
	self isShouldNot ifTrue: [ self expectSameHash: expected ].
	^nil
	
	! !

TestCase subclass: #Phexample
	instanceVariableNames: 'givenNotGiven'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phexample-Core'!

!Phexample commentStamp: 'HenryDorsettCase 11/6/2009 18:56' prior: 0!
Phexample, because well designed tests expand on one another.

Examples see ForExampleStack. 

by Adrian Kuhn and Niko Schwarz  !

Phexample subclass: #ForExampleMatcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phexample-Test'!

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'AdrianNiko 10/14/2009 17:56'!
shouldBeEmpty
  |set|
	set := Set new. 
	set should be isEmpty.
	^set! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'TestRunner 10/27/2009 17:02'!
shouldBeEmpty2
  |set|
	set := Set new. 
	set isEmpty should be true.
	^set! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'AdrianNiko 10/14/2009 17:56'!
shouldBeEven
  4 should be even! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'TestRunner 10/27/2009 17:08'!
shouldBeFalse
  |set|
	set := Set with: 42. 
	set isEmpty should be false.
	^set! !

!ForExampleMatcher methodsFor: 'examples-expecting-reflection' stamp: 'AdrianKuhn 11/9/2009 05:04'!
shouldBeKindOf
	'hello' should beKindOf: String! !

!ForExampleMatcher methodsFor: 'examples-expecting-reflection' stamp: 'AdrianKuhn 11/9/2009 05:04'!
shouldBeKindOfSuperclass
	'hello' should beKindOf: Collection! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'AdrianNiko 10/14/2009 17:56'!
shouldBeOdd
  5 should be odd! !

!ForExampleMatcher methodsFor: 'examples-expecting-string' stamp: 'AdrianKuhn 11/9/2009 08:56'!
shouldBeginWith
	'abcdef' should beginWith: 'abc'.! !

!ForExampleMatcher methodsFor: 'examples-expecting-change' stamp: 'AdrianKuhn 11/9/2009 04:57'!
shouldChange
	| list |
	list := OrderedCollection new.
	[ list add: nil ] should change: [ list size ]! !

!ForExampleMatcher methodsFor: 'examples-expecting-change' stamp: 'AdrianKuhn 11/9/2009 05:00'!
shouldChangeFromTo
	| list |
	list := OrderedCollection new add: nil; add: nil; yourself.
	[ list add: nil ] should change: [ list size ] from: 2 to: 3.! !

!ForExampleMatcher methodsFor: 'examples-expecting-string' stamp: 'AdrianKuhn 11/9/2009 08:57'!
shouldEndWith
	'abcdef' should endWith: 'def'.! !

!ForExampleMatcher methodsFor: 'examples-expecting' stamp: 'TestRunner 10/26/2009 16:46'!
shouldEqualFive
	(2 + 3) should = 5! !

!ForExampleMatcher methodsFor: 'examples' stamp: 'NikoSchwarz 11/11/2009 18:03'!
shouldFailIfRequirementDoesntExist
	[self given: #zork] should signal: TestFailure

! !

!ForExampleMatcher methodsFor: 'examples-expecting' stamp: 'JoeExample 10/27/2009 17:53'!
shouldGreaterThan
  6 should > 5 ! !

!ForExampleMatcher methodsFor: 'examples' stamp: 'TestRunner 10/27/2009 17:30'!
shouldHaveTestsInThisClass
	self class allTestSelectors should not be isEmpty.
	self class allTestSelectors size should > 20.
	
	! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'TestRunner 10/26/2009 16:46'!
shouldIncludeFoo
  |set|
	set := #(foo bar qux). 
	set should be includes: #foo.
	^set! !

!ForExampleMatcher methodsFor: 'examples-expecting' stamp: 'JoeExample 10/27/2009 17:54'!
shouldLesserThan
  5 should < 6! !

!ForExampleMatcher methodsFor: 'examples-expecting-string' stamp: 'TestRunner 11/9/2009 05:37'!
shouldMatchRegex
	'aaa' should matchRegex: 'a*'.! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'TestRunner 10/27/2009 17:07'!
shouldNotBeEmpty
  |set|
	set := Set new. 
	set isEmpty should be true.
	^set! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'TestRunner 10/27/2009 17:05'!
shouldNotBeEven
  5 should not be even! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'TestRunner 10/27/2009 17:08'!
shouldNotBeFalse
  |set|
	set := Set new. 
	set isEmpty should not be false.
	^set! !

!ForExampleMatcher methodsFor: 'examples-expecting-reflection' stamp: 'AdrianKuhn 11/9/2009 10:27'!
shouldNotBeKindOfSubclass
	'hello' should not beKindOf: Symbol! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'TestRunner 10/27/2009 00:12'!
shouldNotBeOdd
  6 should not be odd! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'TestRunner 10/27/2009 17:08'!
shouldNotBeTrue
  |set|
	set := Set with: 42. 
	set isEmpty should not be true.
	^set! !

!ForExampleMatcher methodsFor: 'examples-expecting' stamp: 'TestRunner 10/26/2009 16:46'!
shouldNotEqualSeven
	(2 + 3) should not = 7! !

!ForExampleMatcher methodsFor: 'examples' stamp: 'AdrianKuhn 11/9/2009 05:20'!
shouldNotHaveTestsInEGExample
	Phexample allTestSelectors should be isEmpty.
	
	! !

!ForExampleMatcher methodsFor: 'examples-expecting-string' stamp: 'AdrianKuhn 11/9/2009 05:38'!
shouldNotMatchRegex
	'aaa' should not matchRegex: 'ba*'.! !

!ForExampleMatcher methodsFor: 'examples-expecting-reflection' stamp: 'NikoSchwarz 11/11/2009 18:04'!
shouldNotRespondTo
	Object new should not respondTo: #zork! !

!ForExampleMatcher methodsFor: 'examples-expecting-reflection' stamp: 'NikoSchwarz 11/11/2009 18:02'!
shouldRespondTo
	Object new should respondTo: #yourself! !

!ForExampleMatcher methodsFor: 'examples' stamp: 'JoeExample 10/27/2009 18:46'!
shouldReturnNilWhenTesting
	(5 should = 5) isNil should be true
! !

!ForExampleMatcher methodsFor: 'examples-expecting-performance' stamp: 'AdrianKuhn 11/9/2009 06:11'!
shouldRunWithin
	[ "makes the Kessel Run in less than twelve parsecs" ] should runWithin: 10 milliSeconds ! !

!ForExampleMatcher methodsFor: 'examples-expecting-error' stamp: 'JoeExample 10/27/2009 01:23'!
shouldSignal

	[ 5 should = 6 ] should signal: TestFailure.! !

!ForExampleMatcher methodsFor: 'examples-expecting' stamp: 'JoeExample 10/27/2009 01:23'!
shouldSignalIfFiveShouldNotEqualFive

	[ 5 should not = 5 ] should signal: TestFailure.! !

!ForExampleMatcher methodsFor: 'examples-expecting-error' stamp: 'TestRunner 10/27/2009 01:32'!
shouldSignalIfSignalMissing

	[ [ 5 should = 5 ] should signal: TestFailure ] should 
		signal: TestFailure 
		withMessageText: 'Should raise TestFailure but was none'! !

!ForExampleMatcher methodsFor: 'examples-expecting-error' stamp: 'AdrianKuhn 11/9/2009 05:16'!
shouldSignalIfSignalWrong

	[ [ self error ] should signal: TestFailure ] should 
		signal: TestFailure 
		"withMessageText: 'Expected class TestFailure but was Error'"! !

!ForExampleMatcher methodsFor: 'examples-expecting-reflection' stamp: 'AdrianKuhn 11/9/2009 05:07'!
shouldSignalWhenBeKindOfFails
	[ 'hello' should beKindOf: Number ] should signal: TestFailure! !

!ForExampleMatcher methodsFor: 'examples-expecting-string' stamp: 'TestRunner 11/9/2009 09:04'!
shouldSignalWhenBeginsWithFails
	[ 'abcdef' should beginWith: 'abcX' ] should 
		signal: TestFailure 
		withMessageText: 'expected ''abcX'' but got ''abcdef'' (using beginsWith:)' ! !

!ForExampleMatcher methodsFor: 'examples-expecting-string' stamp: 'TestRunner 11/9/2009 09:03'!
shouldSignalWhenEndWithFails
	[ 'abcdef' should endWith: 'Xdef' ] should 
		signal: TestFailure 
		withMessageText: 'expected ''Xdef'' but got ''abcdef'' (using endsWith:)' ! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'TestRunner 10/27/2009 17:09'!
shouldSignalWhenFalseIsNotFalse
  |set|
	set := Set with: 42. 
	[ set isEmpty should not be false ] should signal: TestFailure.
	^set! !

!ForExampleMatcher methodsFor: 'examples-expecting' stamp: 'TestRunner 11/9/2009 04:33'!
shouldSignalWhenGreaterThanFails
  [ 5 should > 6 ] should signal: TestFailure withMessageText: 'expected 6 but got 5 (using >)'.
  [ 4 should > 4 ] should signal: TestFailure withMessageText: 'expected 4 but got 4 (using >)'.! !

!ForExampleMatcher methodsFor: 'examples-expecting' stamp: 'TestRunner 11/9/2009 04:34'!
shouldSignalWhenLesserThanFails
  [ 6 should < 5 ] should signal: TestFailure withMessageText: 'expected 5 but got 6 (using <)'.
  [ 4 should < 4 ] should signal: TestFailure withMessageText: 'expected 4 but got 4 (using <)'.! !

!ForExampleMatcher methodsFor: 'examples-expecting-string' stamp: 'AdrianKuhn 11/9/2009 05:44'!
shouldSignalWhenMatchRegexFails
	[ 'aaa' should matchRegex: 'ba*' ] should 
		signal: TestFailure 
		withMessageText: 'expected ''ba*'' but got ''aaa'' (using matchesRegex:)'! !

!ForExampleMatcher methodsFor: 'examples-expecting-string' stamp: 'AdrianKuhn 11/9/2009 05:43'!
shouldSignalWhenNotMatchRegexFails
	[ 'aaa' should not matchRegex: 'a*' ] should 
		signal: TestFailure 
		withMessageText: 'expected not to get ''a*'' but got ''aaa'' (using matchesRegex:)'! !

!ForExampleMatcher methodsFor: 'examples-expecting-reflection' stamp: 'AdrianKuhn 11/12/2009 00:38'!
shouldSignalWhenNotRespondToFails
	[ Object new should not respondTo: #yourself ] should
		signal: TestFailure
		withMessageText: 'expected an Object not to respond to #yourself (using respondsTo:)' ! !

!ForExampleMatcher methodsFor: 'examples-expecting-reflection' stamp: 'AdrianKuhn 11/12/2009 00:37'!
shouldSignalWhenRespondToFails
	[ Object new should respondTo: #zork ] should
		signal: TestFailure
		withMessageText: 'expected an Object to respond to #zork (using respondsTo:)' ! !

!ForExampleMatcher methodsFor: 'examples-expecting-performance' stamp: 'AdrianKuhn 11/9/2009 06:28'!
shouldSignalWhenRunWithinFails
	[ [ (Delay forMilliseconds: 20) wait ] should runWithin: 10 milliSeconds ] should signal: TestFailure! !

!ForExampleMatcher methodsFor: 'examples-expecting-boolean' stamp: 'TestRunner 10/27/2009 17:09'!
shouldSignalWhenTrueIsNotTrue
  |set|
	set := Set new. 
	[ set isEmpty should not be true ] should signal: TestFailure.
	^set! !

!ForExampleMatcher methodsFor: 'examples-expecting-error' stamp: 'TestRunner 11/9/2009 04:34'!
shouldSignalWithMessage
	
	[ 5 should = 6 ] should 
		signal: TestFailure
		withMessageText: 'expected 6 but got 5 (using =)'! !

!ForExampleMatcher methodsFor: 'examples-expecting-error' stamp: 'TestRunner 11/9/2009 04:35'!
shouldSignalWithMessageBlock
	
	[ 5 should = 6 ] should 
		signal: TestFailure
		withMessageText: [ :m | 
			m should beKindOf: String.
			m isEmpty should not be true.
			m should = 'expected 6 but got 5 (using =)'.
		]! !

!ForExampleMatcher methodsFor: 'examples-expecting' stamp: 'AdrianKuhn 11/20/2009 18:51'!
shouldTestForSameHashWhenExpectingEqualValues
	| factory probe p |
	factory := ClassFactoryForTestCase new.
	probe := factory 
		newSubclassOf: Object 
		instanceVariableNames: 'counter' 		classVariableNames: ''.
	probe compile: 'initialize counter := 0'.
	probe compile: 'hash ^counter := counter + 1'.
	probe compile: 'printOn: stream stream nextPutAll: ''probe'''.
	p := probe new.
	p hash should = 1.
	p hash should = 2.
	p hash should = 3.
	[ p should = p ] should signal: TestFailure withMessageText: 'Expected same hash for probe and probe (using hash implied by =)'.
	[ p should not ~= p ] should signal: TestFailure withMessageText: 'Expected same hash for probe and probe (using hash implied by =)'.
	factory cleanUp.

! !

Phexample subclass: #ForExampleStack
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phexample-Test'!

!ForExampleStack methodsFor: 'examples' stamp: 'JoeExample 10/27/2009 01:47'!
shouldBeEmpty
	| stack |
	stack := Stack new.
	stack should be isEmpty.
	stack size should = 0.
	^ stack! !

!ForExampleStack methodsFor: 'examples' stamp: 'JoeExample 10/27/2009 01:30'!
shouldFailWhenPopEmpty
	| stack |
	stack := self given: #shouldBeEmpty.
	[ stack pop ] should signal: Error withMessageText: 'this stack is empty'.! !

!ForExampleStack methodsFor: 'examples' stamp: 'JoeExample 10/27/2009 01:40'!
shouldLastInFirstOut
	| stack |
	stack := self given: #shouldPushMoreElements.
	stack pop should = 13.
	stack pop should = 7.
	stack pop should = 42.
	stack should be isEmpty.! !

!ForExampleStack methodsFor: 'examples' stamp: 'TestRunner 10/27/2009 01:11'!
shouldPopElement
	| stack |
	stack := self given: #shouldPushElement.
	stack pop should = 42.
	stack should be isEmpty.
	stack size should = 0.! !

!ForExampleStack methodsFor: 'examples' stamp: 'JoeExample 10/27/2009 10:38'!
shouldPushElement
	| stack |
	stack := self given: #shouldBeEmpty.
	stack push: 42.
	stack should not be isEmpty.
	stack size should = 1.
	stack top should = 42.
	^ stack! !

!ForExampleStack methodsFor: 'examples' stamp: 'JoeExample 10/27/2009 01:38'!
shouldPushMoreElements
	| stack |
	stack := self given: #shouldPushElement.
	stack push: 7.
	stack push: 13.
	stack should not be isEmpty.
	stack size should = 3.
	stack top should = 13.
	^stack! !

!Phexample class methodsFor: 'accessing' stamp: 'JoeExample 11/8/2009 22:33'!
allTestSelectors
	|selectors|
	selectors := self allSelectors clone.
	selectors removeAll: Phexample allSelectors.
	^ selectors select: [:each | 
		('should*' match: each) and: [each numArgs isZero]]
			! !

!Phexample methodsFor: 'private' stamp: 'JoeExample 11/8/2009 22:34'!
cleanUpInstanceVariables
	| names |
	names := self class allInstVarNames asOrderedCollection.
	names removeAll: Phexample allInstVarNames.
	names do: [ :name | self instVarNamed: name put: nil ]! !

!Phexample methodsFor: 'dependencies' stamp: 'AdrianKuhn 11/12/2009 00:35'!
given: anExampleName 
	self should respondTo: anExampleName.
	^ [ self perform: anExampleName ] 
		on: Exception
		do: [ :ex | 
			givenNotGiven := true.
			ex signal ]! !

!Phexample methodsFor: 'private' stamp: 'JoeExample 11/9/2009 09:24'!
shouldPass
	^ super shouldPass and: [ (givenNotGiven = true) not ]! !
